<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGuaranteedAnnualIncomeDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGuaranteedAnnualIncomeDetail
 * @subpackage Arrays
 */
class ArrayOfGuaranteedAnnualIncomeDetail extends AbstractStructArrayBase
{
    /**
     * The GuaranteedAnnualIncomeDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GuaranteedAnnualIncomeDetail[]
     */
    public $GuaranteedAnnualIncomeDetail;
    /**
     * Constructor method for ArrayOfGuaranteedAnnualIncomeDetail
     * @uses ArrayOfGuaranteedAnnualIncomeDetail::setGuaranteedAnnualIncomeDetail()
     * @param \StructType\GuaranteedAnnualIncomeDetail[] $guaranteedAnnualIncomeDetail
     */
    public function __construct(array $guaranteedAnnualIncomeDetail = array())
    {
        $this
            ->setGuaranteedAnnualIncomeDetail($guaranteedAnnualIncomeDetail);
    }
    /**
     * Get GuaranteedAnnualIncomeDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GuaranteedAnnualIncomeDetail[]|null
     */
    public function getGuaranteedAnnualIncomeDetail()
    {
        return isset($this->GuaranteedAnnualIncomeDetail) ? $this->GuaranteedAnnualIncomeDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGuaranteedAnnualIncomeDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuaranteedAnnualIncomeDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuaranteedAnnualIncomeDetailForArrayConstraintsFromSetGuaranteedAnnualIncomeDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGuaranteedAnnualIncomeDetailGuaranteedAnnualIncomeDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfGuaranteedAnnualIncomeDetailGuaranteedAnnualIncomeDetailItem instanceof \StructType\GuaranteedAnnualIncomeDetail) {
                $invalidValues[] = is_object($arrayOfGuaranteedAnnualIncomeDetailGuaranteedAnnualIncomeDetailItem) ? get_class($arrayOfGuaranteedAnnualIncomeDetailGuaranteedAnnualIncomeDetailItem) : sprintf('%s(%s)', gettype($arrayOfGuaranteedAnnualIncomeDetailGuaranteedAnnualIncomeDetailItem), var_export($arrayOfGuaranteedAnnualIncomeDetailGuaranteedAnnualIncomeDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuaranteedAnnualIncomeDetail property can only contain items of type \StructType\GuaranteedAnnualIncomeDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuaranteedAnnualIncomeDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteedAnnualIncomeDetail[] $guaranteedAnnualIncomeDetail
     * @return \ArrayType\ArrayOfGuaranteedAnnualIncomeDetail
     */
    public function setGuaranteedAnnualIncomeDetail(array $guaranteedAnnualIncomeDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($guaranteedAnnualIncomeDetailArrayErrorMessage = self::validateGuaranteedAnnualIncomeDetailForArrayConstraintsFromSetGuaranteedAnnualIncomeDetail($guaranteedAnnualIncomeDetail))) {
            throw new \InvalidArgumentException($guaranteedAnnualIncomeDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($guaranteedAnnualIncomeDetail) || (is_array($guaranteedAnnualIncomeDetail) && empty($guaranteedAnnualIncomeDetail))) {
            unset($this->GuaranteedAnnualIncomeDetail);
        } else {
            $this->GuaranteedAnnualIncomeDetail = $guaranteedAnnualIncomeDetail;
        }
        return $this;
    }
    /**
     * Add item to GuaranteedAnnualIncomeDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\GuaranteedAnnualIncomeDetail $item
     * @return \ArrayType\ArrayOfGuaranteedAnnualIncomeDetail
     */
    public function addToGuaranteedAnnualIncomeDetail(\StructType\GuaranteedAnnualIncomeDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GuaranteedAnnualIncomeDetail) {
            throw new \InvalidArgumentException(sprintf('The GuaranteedAnnualIncomeDetail property can only contain items of type \StructType\GuaranteedAnnualIncomeDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuaranteedAnnualIncomeDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GuaranteedAnnualIncomeDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GuaranteedAnnualIncomeDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GuaranteedAnnualIncomeDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GuaranteedAnnualIncomeDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GuaranteedAnnualIncomeDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GuaranteedAnnualIncomeDetail
     */
    public function getAttributeName()
    {
        return 'GuaranteedAnnualIncomeDetail';
    }
}
