<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdviserCharges StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AdviserCharges
 * @subpackage Structs
 */
class AdviserCharges extends AbstractStructBase
{
    /**
     * The AdviserChargeFacilitatedByProvider
     * @var bool
     */
    public $AdviserChargeFacilitatedByProvider;
    /**
     * The InitialAdviserCharges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InitialAdviserCharges
     */
    public $InitialAdviserCharges;
    /**
     * The OngoingAdviserCharges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OngoingAdviserCharges
     */
    public $OngoingAdviserCharges;
    /**
     * Constructor method for AdviserCharges
     * @uses AdviserCharges::setAdviserChargeFacilitatedByProvider()
     * @uses AdviserCharges::setInitialAdviserCharges()
     * @uses AdviserCharges::setOngoingAdviserCharges()
     * @param bool $adviserChargeFacilitatedByProvider
     * @param \StructType\InitialAdviserCharges $initialAdviserCharges
     * @param \StructType\OngoingAdviserCharges $ongoingAdviserCharges
     */
    public function __construct($adviserChargeFacilitatedByProvider = null, \StructType\InitialAdviserCharges $initialAdviserCharges = null, \StructType\OngoingAdviserCharges $ongoingAdviserCharges = null)
    {
        $this
            ->setAdviserChargeFacilitatedByProvider($adviserChargeFacilitatedByProvider)
            ->setInitialAdviserCharges($initialAdviserCharges)
            ->setOngoingAdviserCharges($ongoingAdviserCharges);
    }
    /**
     * Get AdviserChargeFacilitatedByProvider value
     * @return bool|null
     */
    public function getAdviserChargeFacilitatedByProvider()
    {
        return $this->AdviserChargeFacilitatedByProvider;
    }
    /**
     * Set AdviserChargeFacilitatedByProvider value
     * @param bool $adviserChargeFacilitatedByProvider
     * @return \StructType\AdviserCharges
     */
    public function setAdviserChargeFacilitatedByProvider($adviserChargeFacilitatedByProvider = null)
    {
        // validation for constraint: boolean
        if (!is_null($adviserChargeFacilitatedByProvider) && !is_bool($adviserChargeFacilitatedByProvider)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($adviserChargeFacilitatedByProvider, true), gettype($adviserChargeFacilitatedByProvider)), __LINE__);
        }
        $this->AdviserChargeFacilitatedByProvider = $adviserChargeFacilitatedByProvider;
        return $this;
    }
    /**
     * Get InitialAdviserCharges value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InitialAdviserCharges|null
     */
    public function getInitialAdviserCharges()
    {
        return isset($this->InitialAdviserCharges) ? $this->InitialAdviserCharges : null;
    }
    /**
     * Set InitialAdviserCharges value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\InitialAdviserCharges $initialAdviserCharges
     * @return \StructType\AdviserCharges
     */
    public function setInitialAdviserCharges(\StructType\InitialAdviserCharges $initialAdviserCharges = null)
    {
        if (is_null($initialAdviserCharges) || (is_array($initialAdviserCharges) && empty($initialAdviserCharges))) {
            unset($this->InitialAdviserCharges);
        } else {
            $this->InitialAdviserCharges = $initialAdviserCharges;
        }
        return $this;
    }
    /**
     * Get OngoingAdviserCharges value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OngoingAdviserCharges|null
     */
    public function getOngoingAdviserCharges()
    {
        return isset($this->OngoingAdviserCharges) ? $this->OngoingAdviserCharges : null;
    }
    /**
     * Set OngoingAdviserCharges value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\OngoingAdviserCharges $ongoingAdviserCharges
     * @return \StructType\AdviserCharges
     */
    public function setOngoingAdviserCharges(\StructType\OngoingAdviserCharges $ongoingAdviserCharges = null)
    {
        if (is_null($ongoingAdviserCharges) || (is_array($ongoingAdviserCharges) && empty($ongoingAdviserCharges))) {
            unset($this->OngoingAdviserCharges);
        } else {
            $this->OngoingAdviserCharges = $ongoingAdviserCharges;
        }
        return $this;
    }
}
