<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ComparisonQuoteRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ComparisonQuoteRequest
 * @subpackage Structs
 */
class ComparisonQuoteRequest extends AbstractStructBase
{
    /**
     * The ProvidersRequested
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $ProvidersRequested;
    /**
     * The TransactionHeaders
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\TransactionHeaders
     */
    public $TransactionHeaders;
    /**
     * Constructor method for ComparisonQuoteRequest
     * @uses ComparisonQuoteRequest::setProvidersRequested()
     * @uses ComparisonQuoteRequest::setTransactionHeaders()
     * @param \ArrayType\ArrayOfstring $providersRequested
     * @param \StructType\TransactionHeaders $transactionHeaders
     */
    public function __construct(\ArrayType\ArrayOfstring $providersRequested = null, \StructType\TransactionHeaders $transactionHeaders = null)
    {
        $this
            ->setProvidersRequested($providersRequested)
            ->setTransactionHeaders($transactionHeaders);
    }
    /**
     * Get ProvidersRequested value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getProvidersRequested()
    {
        return isset($this->ProvidersRequested) ? $this->ProvidersRequested : null;
    }
    /**
     * Set ProvidersRequested value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $providersRequested
     * @return \StructType\ComparisonQuoteRequest
     */
    public function setProvidersRequested(\ArrayType\ArrayOfstring $providersRequested = null)
    {
        if (is_null($providersRequested) || (is_array($providersRequested) && empty($providersRequested))) {
            unset($this->ProvidersRequested);
        } else {
            $this->ProvidersRequested = $providersRequested;
        }
        return $this;
    }
    /**
     * Get TransactionHeaders value
     * @return \StructType\TransactionHeaders|null
     */
    public function getTransactionHeaders()
    {
        return $this->TransactionHeaders;
    }
    /**
     * Set TransactionHeaders value
     * @param \StructType\TransactionHeaders $transactionHeaders
     * @return \StructType\ComparisonQuoteRequest
     */
    public function setTransactionHeaders(\StructType\TransactionHeaders $transactionHeaders = null)
    {
        $this->TransactionHeaders = $transactionHeaders;
        return $this;
    }
}
