<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OngoingAdviserCharges StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OngoingAdviserCharges
 * @subpackage Structs
 */
class OngoingAdviserCharges extends AbstractStructBase
{
    /**
     * The FixedAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ChargeAmount
     */
    public $FixedAmount;
    /**
     * The PercentageOfFundValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ChargePercentage
     */
    public $PercentageOfFundValue;
    /**
     * Constructor method for OngoingAdviserCharges
     * @uses OngoingAdviserCharges::setFixedAmount()
     * @uses OngoingAdviserCharges::setPercentageOfFundValue()
     * @param \StructType\ChargeAmount $fixedAmount
     * @param \StructType\ChargePercentage $percentageOfFundValue
     */
    public function __construct(\StructType\ChargeAmount $fixedAmount = null, \StructType\ChargePercentage $percentageOfFundValue = null)
    {
        $this
            ->setFixedAmount($fixedAmount)
            ->setPercentageOfFundValue($percentageOfFundValue);
    }
    /**
     * Get FixedAmount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ChargeAmount|null
     */
    public function getFixedAmount()
    {
        return isset($this->FixedAmount) ? $this->FixedAmount : null;
    }
    /**
     * Set FixedAmount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ChargeAmount $fixedAmount
     * @return \StructType\OngoingAdviserCharges
     */
    public function setFixedAmount(\StructType\ChargeAmount $fixedAmount = null)
    {
        if (is_null($fixedAmount) || (is_array($fixedAmount) && empty($fixedAmount))) {
            unset($this->FixedAmount);
        } else {
            $this->FixedAmount = $fixedAmount;
        }
        return $this;
    }
    /**
     * Get PercentageOfFundValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ChargePercentage|null
     */
    public function getPercentageOfFundValue()
    {
        return isset($this->PercentageOfFundValue) ? $this->PercentageOfFundValue : null;
    }
    /**
     * Set PercentageOfFundValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ChargePercentage $percentageOfFundValue
     * @return \StructType\OngoingAdviserCharges
     */
    public function setPercentageOfFundValue(\StructType\ChargePercentage $percentageOfFundValue = null)
    {
        if (is_null($percentageOfFundValue) || (is_array($percentageOfFundValue) && empty($percentageOfFundValue))) {
            unset($this->PercentageOfFundValue);
        } else {
            $this->PercentageOfFundValue = $percentageOfFundValue;
        }
        return $this;
    }
}
